

(defprotocol bb1 basic 
  (defrole init
    (vars (a b name) (s text) (k skey))
    (trace
     (send (enc (enc k (privk a)) (pubk b)))
     (recv (enc s k))))
  (defrole resp
    (vars (a b name) (s text) (k skey))
    (trace
     (recv (enc (enc k (privk a)) (pubk b)))
     (send (enc s k)))))

(defpreskeleton bb1 
  (vars (a b name) (s text) (k skey))
  (defstrand init 2 (a a) (b b) (k k))
  (non-orig (privk b) (privk a))
  (uniq-orig k))

(defpreskeleton bb1 
  (vars (a b name) (s text) (k skey))
  (defstrand init 2 (a a) (b b) (s s) (k k))
  (deflistener s)
  (non-orig (privk b) (privk a))
  (uniq-orig s k))

(defpreskeleton bb1 
  (vars (a b name) (s text) (k skey))
  (defstrand resp 2 (a a) (b b) (k k))
  (non-orig (privk b) (privk a))
  (uniq-orig k))

(defpreskeleton bb1 
  (vars (a b name) (s text) (k skey))
  (defstrand resp 2 (a a) (b b) (s s) (k k))
  (deflistener s)
  (non-orig (privk b) (privk a))
  (uniq-orig k s))

(defprotocol bb2 basic 
  (defrole init
    (vars (a b name) (s text) (k skey))
    (trace
     (send (enc (enc k b (privk a)) (pubk b)))
     (recv (enc s k))))
  (defrole resp
    (vars (a b name) (s text) (k skey))
    (trace
     (recv (enc (enc k b (privk a)) (pubk b)))
     (send (enc s k)))))

(defpreskeleton bb2 
  (vars (a b name) (s text) (k skey))
  (defstrand init 2 (a a) (b b) (k k))
  (non-orig (privk b) (privk a))
  (uniq-orig k))

(defpreskeleton bb2 
  (vars (a b name) (s text) (k skey))
  (defstrand init 2 (a a) (b b) (s s) (k k))
  (deflistener s)
  (non-orig (privk b) (privk a))
  (uniq-orig s k))

(defpreskeleton bb2 
  (vars (a b name) (s text) (k skey))
  (defstrand resp 2 (a a) (b b) (k k))
  (non-orig (privk b) (privk a))
  (uniq-orig k))

(defpreskeleton bb2 
  (vars (a b name) (s text) (k skey))
  (defstrand resp 2 (a a) (b b) (s s) (k k))
  (deflistener s)
  (non-orig (privk b) (privk a))
  (uniq-orig k s))