(herald "Perrig-Song Example protocol"
	(comment "auth failure known to them."))

(defprotocol ps basic 
  (defrole init 
    (vars (my_init_id yr_resp_id name) (n1 n2 text))
    (trace
     (send (cat my_init_id n1))
     (recv (enc n1 n2 (ltk my_init_id yr_resp_id)))
     (send n2)))
  (defrole resp 
    (vars (my_resp_id yr_init_id name) (n2 n1 text))
    (trace 
     (recv (cat yr_init_id n1))
     (send (enc n1 n2 (ltk yr_init_id my_resp_id)))
     (recv n2))))

(defskeleton ps
  (vars (a b name) (n1 text))
  (defstrand init 3 (my_init_id a) (yr_resp_id b) (n1 n1))
  (non-orig (ltk a b))
  (uniq-orig n1)
  (comment "Initiator point-of-view"))
	      
     
